import { z, ZodType } from "zod";
export declare type Models<Key extends string = string> = {
    readonly [K in Key]: ZodType<unknown>;
};
export declare type SchemaKey<M extends Models> = M extends Models<infer Key> ? Key & string : never;
export declare type SchemaKeyOrDescription<M extends Models> = SchemaKey<M> | {
    readonly description: string;
    readonly key: SchemaKey<M>;
};
declare type SchemaType<M extends Models, Key extends SchemaKey<M>> = z.infer<M[Key]>;
export declare type SchemaTypeOption<M extends Models, Key extends void | SchemaKey<M>> = Key extends SchemaKey<M> ? SchemaType<M, Key> : void;
export {};
